CodeForces 596A

Description

After making bad dives into swimming pools, Wilbur wants to build a swimming

pool in the shape of a rectangle in his backyard. He has set up coordinate axes,

and he wants the sides of the rectangle to be parallel to them. Of course, the

area of the rectangle must be positive. Wilbur had all four vertices of the planned

pool written on a paper, until his friend came along and erased some of the

vertices.Now Wilbur is wondering, if the remaining n vertices of the initial rectangle

give enough information to restore the area of the planned swimming pool.

Input

The first line of the input contains a single integer n (1 ≤ n ≤ 4) — the number of

vertices that were not erased by Wilbur‘s friend.

Each of the following n lines contains two integers xi and yi ( - 1000 ≤ xi, yi ≤ 1000)

—the coordinates of the i-th vertex that remains. Vertices are given in an arbitrary

order.It‘s guaranteed that these points are distinct vertices of some rectangle, that

has positive area and which sides are parallel to the coordinate axes.

Output

Print the area of the initial rectangle if it could be uniquely determined by the points

remaining. Otherwise, print  - 1.

Sample Input

Input

20 01 1

Output

1

Input

11 1

Output

-1

Hint

In the first sample, two opposite corners of the initial rectangle are given, and that

gives enough information to say that the rectangle is actually a unit square.

In the second sample there is only one vertex left and this is definitely not enough

to uniquely define the area.

一道签到题,然而我却wa了很多次,我一直以为是让我判断长方形,发现还要输出面积。。。。

 1 #include<iostream>
 2 #include<cmath>
 3 #include<cstdio>
 4 #include<algorithm>
 5 using namespace std;
 6 struct node
 7 {
 8     int x,y;
 9 }a[100];
10 int main()
11 {
12     int n,i,j;
13     cin>>n;
14     for(i=1;i<=n;i++)
15         cin>>a[i].x>>a[i].y;
16     if(n==1)
17     {
18         cout<<"-1"<<endl;
19     }
20     else if(n==2)
21     {
22         if(a[1].x==a[2].x||a[1].y==a[2].y)
23         {
24             cout<<"-1"<<endl;
25         }
26         else
27             cout<<abs(a[1].x-a[2].x)*abs(a[2].y-a[1].y)<<endl;
28     }
29     else
30     {
31         for(i=1;i<=n;i++)
32         {
33             for(j=1;j<=n;j++)
34             {
35                 if(a[i].x!=a[j].x&&a[i].y!=a[j].y)
36                 {
37                     cout<<abs(a[i].x-a[j].x)*abs(a[i].y-a[j].y)<<endl;
38                     return  0;
39                 }
40             }
41         }
42         cout<<"-1"<<endl;
43     }
44     return 0;
45 }
时间: 2024-08-05 11:14:11

CodeForces 596A的相关文章

CodeForces 596A Wilbur and Swimming Pool

水题. #include<cstdio> #include<cstring> #include<cmath> #include<algorithm> using namespace std; struct X { int x,y; }s[5],tmp[5]; int n; int main() { scanf("%d",&n); for(int i=1;i<=n;i++) scanf("%d%d",&am

【codeforces 718E】E. Matvey&#39;s Birthday

题目大意&链接: http://codeforces.com/problemset/problem/718/E 给一个长为n(n<=100 000)的只包含‘a’~‘h’8个字符的字符串s.两个位置i,j(i!=j)存在一条边,当且仅当|i-j|==1或s[i]==s[j].求这个无向图的直径,以及直径数量. 题解:  命题1:任意位置之间距离不会大于15. 证明:对于任意两个位置i,j之间,其所经过每种字符不会超过2个(因为相同字符会连边),所以i,j经过节点至多为16,也就意味着边数至多

Codeforces 124A - The number of positions

题目链接:http://codeforces.com/problemset/problem/124/A Petr stands in line of n people, but he doesn't know exactly which position he occupies. He can say that there are no less than a people standing in front of him and no more than b people standing b

Codeforces 841D Leha and another game about graph - 差分

Leha plays a computer game, where is on each level is given a connected graph with n vertices and m edges. Graph can contain multiple edges, but can not contain self loops. Each vertex has an integer di, which can be equal to 0, 1 or  - 1. To pass th

Codeforces Round #286 (Div. 1) A. Mr. Kitayuta, the Treasure Hunter DP

链接: http://codeforces.com/problemset/problem/506/A 题意: 给出30000个岛,有n个宝石分布在上面,第一步到d位置,每次走的距离与上一步的差距不大于1,问走完一路最多捡到多少块宝石. 题解: 容易想到DP,dp[i][j]表示到达 i 处,现在步长为 j 时最多收集到的财富,转移也不难,cnt[i]表示 i 处的财富. dp[i+step-1] = max(dp[i+step-1],dp[i][j]+cnt[i+step+1]) dp[i+st

Codeforces 772A Voltage Keepsake - 二分答案

You have n devices that you want to use simultaneously. The i-th device uses ai units of power per second. This usage is continuous. That is, in λ seconds, the device will use λ·ai units of power. The i-th device currently has bi units of power store

Educational Codeforces Round 21 G. Anthem of Berland(dp+kmp)

题目链接:Educational Codeforces Round 21 G. Anthem of Berland 题意: 给你两个字符串,第一个字符串包含问号,问号可以变成任意字符串. 问你第一个字符串最多包含多少个第二个字符串. 题解: 考虑dp[i][j],表示当前考虑到第一个串的第i位,已经匹配到第二个字符串的第j位. 这样的话复杂度为26*n*m*O(fail). fail可以用kmp进行预处理,将26个字母全部处理出来,这样复杂度就变成了26*n*m. 状态转移看代码(就是一个kmp

Codeforces Round #408 (Div. 2) B

Description Zane the wizard is going to perform a magic show shuffling the cups. There are n cups, numbered from 1 to n, placed along the x-axis on a table that has m holes on it. More precisely, cup i is on the table at the position x?=?i. The probl

Codeforces 617 E. XOR and Favorite Number

题目链接:http://codeforces.com/problemset/problem/617/E 一看这种区间查询的题目,考虑一下莫队. 如何${O(1)}$的修改和查询呢? 令${f(i,j)}$表示区间${\left [ l,r \right ]}$内数字的异或和. 那么:${f(l,r)=f(1,r)~~xor~~f(1,l-1)=k}$ 记一下前缀异或和即可维护. 1 #include<iostream> 2 #include<cstdio> 3 #include&l